\newcommand{\C}{\mathbb{C}}
\newcommand{\R}{\mathbb{R}}
\newcommand{\Z}{\mathbb{Z}}
\newcommand{\N}{\mathbb{N}}

\newcommand{\vf}{\varphi}
\newcommand{\ve}{\varepsilon}
\newcommand{\hess}{\nabla}
\newcommand{\lagr}{\mcal L}
\newcommand{\ident}{\mathbb{I}}
\newcommand{\noise}{\mcal{N}}
\newcommand{\iid}{\overset{\text{iid}}{\sim}}
\newcommand{\ind}{\overset{\text{ind}}{\sim}}

\newcommand{\tr}{\top}
\newcommand{\Tr}{^\tr}
\newcommand{\pinv}{\dagger}
\newcommand{\Pinv}{^\dagger}

\newcommand{\norm}[1]{\left\lVert #1 \right\rVert}
\newcommand{\scal}[2]{\left\langle #1, #2 \right\rangle}
\newcommand{\absval}[1]{\left| #1 \right|}
\newcommand{\avg}[1]{\overline{#1}}

\newcommand{\mtr}[1]{\begin{pmatrix}#1\end{pmatrix}}
\newcommand{\bmtr}[1]{\begin{bmatrix}#1\end{bmatrix}}

\newcommand{\mcal}[1]{\mathcal{#1}}

\newcommand{\vi}[1]{\boldsymbol{#1}}
\newcommand{\dvi}[1]{\vi{\dot{#1}}}
\newcommand{\vii}[1]{\mathbf{#1}}
\newcommand{\dvii}[1]{\vii{\dot{#1}}}
\newcommand{\vr}[1]{\mathbf{#1}}
\newcommand{\dvr}[1]{\vr{\dot{#1}}}
\newcommand{\vb}[1]{\pmb{#1}}
\newcommand{\dvb}[1]{\vb{\dot{#1}}}

\newcommand{\set}[1]{\left\{#1\right\}}
\newcommand{\brackets}[1]{\left( #1 \right)}

\let\d\relax
\DeclareMathOperator{\d}{\mathrm{d}}

\newcommand{\partialDeriv}[2]{\frac {\partial #1} {\partial #2}}
\newcommand{\partialOp}[1]{\frac {\partial} {\partial #1}}
\newcommand{\deriv}[2]{\frac {\d #1} {\d #2}}
\newcommand{\derivOp}[1]{\frac {\d} {\d #1}\,}

\newcommand{\dom}[1]{\mcal{D}\, \brackets{#1}}
\newcommand{\floor}[1]{\left\lfloor #1 \right\rfloor}

\newcommand{\id}{\mathrm{id}}
\newcommand{\stdev}{\sigma}
\newcommand{\sOnTop}[2]{\mathrel{\overset{\makebox[0pt]{\mbox{\normalfont #2}}}{#1}}}
\newcommand{\EQ}{\sOnTop{=}{!}}
\newcommand{\isPDef}{\sOnTop{\succ}{?}}
\newcommand{\onTop}[2]{\mathrel{\overset{\makebox[0pt]{\mbox{\normalfont\tiny\sffamily #2}}}{#1}}}

\DeclareMathOperator{\im}{im}
\DeclareMathOperator{\tg}{tg}
\DeclareMathOperator{\grad}{grad}
\DeclareMathOperator*{\argmin}{argmin}
\DeclareMathOperator{\prox}{prox}
\DeclareMathOperator{\sign}{sign}
\DeclareMathOperator{\loss}{loss}
\DeclareMathOperator{\osc}{osc}
\DeclareMathOperator{\variance}{Var}
\DeclareMathOperator{\supp}{supp}
\DeclareMathOperator{\card}{card}

\newcommand{\xx}{\vi x}
\newcommand{\Koop}{\mcal K}

\newcommand{\constraint}{\text{s.t.}\;}

\newcommand{\oneToN}[1]{\left[#1\right]}
